#!/usr/bin/perl

############
# DEFINITIONS
 
$site=$ENV{HTTP_HOST};                          ## your domain
$color = "0080C0";                              ## color for font and sidebars
$redirect = "http://$site/";                    ## your URL
$webmaster = "aleeanne\@aleeanne.org.uk";          ## webmaster's email address
$mailprogram = "/usr/sbin/sendmail";            ## sendmail location
$header = "unknown error";
$explanation = "no explanation";
$status = "unknown re-direct status code";

############
# PROGRAM
 
&ReadParse;
&WhichError;
&TellWebmaster;
&SendPage;
 
############
# SUB PROGRAMS
 
#### ReadParse ####
sub ReadParse {
  local (*in) = @_ if @_;
  local ($i, $key, $val);
  if (&MethGet) {
    $in = $ENV{'QUERY_STRING'};
  } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }
  @in = split(/&/,$in);
  foreach $i (0 .. $#in) {
    $in[$i] =~ s/\+/ /g;
    ($key, $val) = split(/=/,$in[$i],2);
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $in{$key} .= "\0" if (defined($in{$key}));
    $in{$key} .= $val;
  }
  return length($in);
}

sub MethGet {
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}

sub WhichError {
$status = $ENV{'REDIRECT_STATUS'};
 
if($status eq "400") {
  $header = "400 Bad Request";
  $explanation = "your browser sent a request which could not be understood by the server due to incorrect syntax.";
} elsif($status eq "401") {
  $header = "401 Unauthorized";
  $explanation = "your browser sent the server a request which requires user authentication. You are not authorized to access this page.";
} elsif($status eq "402") {
  $header = "402 Payment Required";
  $explanation = "your sent the server a request which was refused. Access to this area is restricted to paying customers.";
} elsif($status eq "403") {
  $header = "403 Forbidden";
  $explanation = "your browser requested a page which is not available to the public.";
} elsif($status eq "404") {
  $header = "404 Not Found";
  $explanation = "your browser requested an address, but the server could not find anything which matched.";
} elsif($status eq "405") {
  $header = "405 Method Not Allowed";
  $explanation = "your browser sent the server a request for software which is not available.";
} elsif($status eq "406") {
  $header = "406 Not Acceptable";
  $explanation = "your browser sent a request which was not accepted by the server.";
} elsif($status eq "407") {
  $header = "407 Proxy Authentication Required";
  $explanation = "your browser sent the server a request for a proxy resource, but did not identify your machine as an authorized user.";
} elsif($status eq "408") {
  $header = "408 Request Time-Out";
  $explanation = "your browser sent the server a request which took too long to process. The server has timed out.";
} elsif($status eq "409") {
  $header = "409 Conflict";
  $explanation = "your browser sent the server a request which conflicts with another process running simultaneously.";
} elsif($status eq "410") {
  $header = "410 Gone";
  $explanation = "your browser sent the server a request for a page which appears to have gone.";
} elsif($status eq "411") {
  $header = "411 Length Required";
  $explanation = "your browser failed to deliver the whole length of its request to the server.";
} elsif($status eq "412") {
  $header = "412 Precondition Failed";
  $explanation = "your browser sent the server a request for data which requires a precondition which was not fulfilled.";
} elsif($status eq "413") {
  $header = "413 Request Entity Too Large";
  $explanation = "your browser sent the server a request for data too large to deliver.";
} elsif($status eq "414") {
  $header = "414 Request URL Too Large";
  $explanation = "your browser sent the server a request for an internet address which was thousands of characters long.";
} elsif($status eq "415") {
  $header = "415 Unsupported Media Type";
  $explanation = "your sent the server a request to deliver some media which it does not have the software to play.";
} elsif($status eq "500") {
  $header = "500 Internal Server Error";
  $explanation = " the server encountered an unexpected condition which prevented it from fulfilling your request.";
} elsif($status eq "501") {
  $header = "501 Not Implemented";
  $explanation = "the server does not recognize the software your browser is requesting.";
} elsif($status eq "502") {
  $header = "502 Bad Gateway";
  $explanation = "the server received an invalid response from another server farther upstream.";
} elsif($status eq "503") {
  $header = "503 Service Unavailable";
  $explanation = "the server is currently unable to handle the request due to a temporary overloading or maintenance.";
} elsif($status eq "504") {
  $header = "504 Gateway Time-Out";
  $explanation = "your request took too long for the server to process.";
} elsif($status eq "505") {
  $header = "505 HTTP Version Not Supported";
  $explanation = "your browser has required a HyperText Transfer Protocol version which is not available.";
} else {
  $header = "Unrecognized Error";
  $explanation = "the server encountered an unrecognized error in the data transmission.";
}
}

#### tell me the error
sub TellWebmaster {
$now = localtime();
 
  open(MAIL, "|$mailprogram -t") || goto SKIPMAIL;
 
print MAIL "To: $webmaster\n";
print MAIL "From: Error Robot for $site\n";
print MAIL "Subject: $header Error\n";
print MAIL "On $now the server generated a custom error page for:\n\n $site\n\n";
print MAIL "Error status number and message\n===============================\n $status\n\n";
print MAIL "$header\n";
print MAIL "$explanation\n\n";
print MAIL "User details (if applicable)\n============================\n $in{'user'}\n\n";
print MAIL "More detailed information\n==========================\n";
foreach $key (sort keys(%ENV)) {print MAIL "$key:\n$ENV{$key}\n\n";}
close (MAIL);
 
SKIPMAIL:
}

sub SendPage {

print "Content-type: text/html\n\n";


print <<EOF;
<HTML>
<HEAD>
<TITLE>Aleeanne Homepage - Server Error - Argh!</TITLE>
</HEAD>
<BODY TEXT="#FFFFFF" BGCOLOR="#000000" LINK="#00CC00" VLINK="#0000FF" ALINK="#0000FF">
<!-- <CENTER><IMG ALT="Turn your images on!" SRC="/gifs/Url.gif" WIDTH=595 HEIGHT=82" border=0>
-->
<p>
<H1>$header</H1>
<P><font size=-1>There has been an error because $explanation
<P>To return to $site, press the button below,
<P align=Center><FORM ACTION="$redirect"><INPUT TYPE=Submit VALUE="Return to $site"></FORM>
<P>&nbsp;
<P>This error message has been forwarded to the Server Administrator, however if the errors persist, please contact the <A HREF="mailto:$webmaster">Webmaster</A>.</font>
</Center>
</BODY>
</HTML>
EOF

}
