#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/errno.h>

#include "cin.h"
#include "http_init.h"

extern int errno;
int s=-1;
struct sockaddr ss;
int status=0;
char accttype[8];
char homepage[64];

#define MSG_DONTWAIT (0)

void closesocket(void)
{
 if(s!=-1) {
  close(s);
  s=-1;
 }
}

int opensocket(void)
{
 int on=1;
 
 ss.sa_data[0]=0x0a;
 ss.sa_data[1]=0xce;
 ss.sa_data[2]=127;
 ss.sa_data[3]=0;
 ss.sa_data[4]=0;
 ss.sa_data[5]=1;
 s=socket(PF_INET,SOCK_STREAM,0);
 if(s==-1) {
  return 0;
 }
 atexit(closesocket);
 ss.sa_family=AF_INET;
 if(connect(s,&ss,sizeof(struct sockaddr))<0) {
  closesocket();
  return 0;
 }
 return 1;
}

char *readline(void)
{
 int cc;
 static char line[1024];
 int lpos=0;
 char buffer[4];

 lpos=0;
 do {
  cc=recv(s,buffer,1,MSG_DONTWAIT);
  if(cc>0) {
   if(*buffer==0x0a) *buffer=0;
   line[lpos++]=*buffer;
   if(*buffer==0) return line;
  } else {
   if((errno!=EWOULDBLOCK)||(cc==0)) {
    closesocket();
    return 0;
   }
  }
 } while(1);
}

int sendbyte(char n)
{
 int cc;

 do {
  cc=send(s,&n,1,MSG_DONTWAIT);
  if(cc<=0) {
   if((errno!=EWOULDBLOCK)||(cc==0)) {
    closesocket();
    return 0;
   }
  }
 } while(cc==0);
 return 1;
}

int writeline(char *str,int cr)
{
 char *p=str;

 while(*p>=' ') {
  if(sendbyte(*p)==0) return 0;
  p++;
 }
 if(cr) return sendbyte(10);
 return 1;
}

int frame;

int main(int argn, char **argc)
{
 char *line;

 init_http();

 if(opensocket()==0) exit(0*printf("Connection refused\n"));

 if(writeline("Get /customer_info",1)==0) exit(0*printf("Connection terminated\n"));
 if(writeline("Customer_Code:",0)==0) exit(0*printf("Connection terminated\n"));
 if(writeline(get_content("cid"),1)==0) exit(0*printf("Connection terminated\n"));
 writeline("",1);

 do {
  line=readline();
  if((line)&&(*line)) {
   char *p=line;
   while((*p)&&(*p!=':')) p++;
   if(*p) {
    *p++=0;
    while(*p==' ') p++;
    if(strcasecmp(line,"home_page_title")==0) strcpy(homepage,p);
    if(strcasecmp(line,"account_type_id")==0) strcpy(accttype,p);
   }
  }
 } while(line);

 set_code('C',get_content("cid"));
 set_code('A',accttype);
 set_code('G',homepage);

 if(get_content("frame")==0) {
  strcpy(accttype,"1");
  frame=0;
 } else frame=atoi(get_content("frame"));
 switch(frame) {
  case 0 : /* Defining frame */
  process_html("/meta/apache/arghomedocs/index.html",atoi(accttype));
  break;
  case 1 : /* Top frame */
  process_html("/meta/apache/arghomedocs/title.html",atoi(accttype));
  break;
  case 2 : /* Bottom frame */
  process_html("/meta/apache/arghomedocs/base.html",atoi(accttype));
  break;
 }
 closesocket();
 /* printf("Connection ended\n");*/
}

