#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

static char **content_tag,**content_str;
static int contents;

long int cid_seed[30]={ 0x13625f43,
			0x3eb735a9,
			0x2746f9bb,
			0x29545ed1,
			0x10329556,
			0x07f84672,
			0x1126635f,
			0x1d105730,
			0x0db2214e,
			0x04b97453,
			0x0f37572c,
			0x194ffedb,
			0x08159500,
			0x1dfbdd92,
			0x1787020e,
			0x04260021,
			0x0146f515,
			0x0530032e,
			0x12e63872,
			0x102151f6,
			0x07003203,
			0x126fdaa8,
			0x19a99fe3,
			0x118563f6,
			0x08749fa4,
			0x05445bbc,
			0x1e113113,
			0x1d234567,
			0x1a26feed,
			0x0fba1150};

static int cin_swap[30];

static char cin_digit[33]="0123456789ABCDEFGHJKLMNPQRTUVWXY";

void cin_init(void)
{
 int i,j,a,b;

 for(i=0;i<30;i++) {
  cin_swap[i]=i;
 }
 for(i=0;i<30;i++) {
  a=(i*2+(i>>1))%30;
  b=(i*5+(i>>2)+7)%30;
  j=cin_swap[a];
  cin_swap[a]=cin_swap[b];
  cin_swap[b]=j;
 }
}

char *cid2cin(long int id)
{
 long int i,j,k,l;
 int a,b,c,d;
 static char str[16];

 cin_init();

 i=id ^ 0x1de86375l;
 k=0;

 for(a=0;a<30;a++) {
  if(i & (1<<cin_swap[a])) k|=(1<<a);
 }

 i=k;

 j=0x37777777l;

 for(a=0;a<30;a++) {
  if(i & (1<<a)) j^=cid_seed[a];
 }

 for(a=0;a<6;a++) {
  i&=0x3fffffffl;
  j&=0x3fffffffl;
  str[a*2]=cin_digit[i & 0x1f];
  str[a*2+1]=cin_digit[j & 0x1f];
  i=(i>>5);
  j=(j>>5);
 }
 str[12]=0;

 return str;
}

int cind2n(char n)
{
 int a;

 for(a=0;a<32;a++) {
  if(n==cin_digit[a]) return a;
 }
 return 0;
}

long int cin2cid(char *sstr)
{
 long int i,j;
 int a;
 char str[16],*c,*b;

 c=sstr;
 b=str;

 while(*c) {
  if(*c!=' ') {
   *b=*c;
   if(*b=='l') *b='1';
   if(*b>='a') *b=toupper(*b);
   if(*b=='Z') *b='2';
   if(*b=='I') *b='1';
   if(*b=='O') *b='0';
   if(*b=='S') *b='5';
   b++;
  }
  c++;
 }
 *b=0;
 if(strlen(str)!=12) return -1;

 cin_init();

 i=0;
 for(a=0;a<6;a++) {
  i|=cind2n(str[a<<1])<<(a*5);
 }

 j=0;
 for(a=0;a<30;a++) {
  if(i & (1<<a)) {
   j|=1<<cin_swap[a];
  }
 }
 j^=0x1de86375l;

 if(strcmp(str,cid2cin(j))==0) return j;

 return -1;
}

void server_error(char *reason)
{
 printf("<html><head><title>Server Error</title></head>\n");
 printf("<body><h1>Server Error</h1>\n");
 printf("%s\n</body></html>",reason);
 fflush(stdout);
 return;
}

int check_host(void)
{
  /* if(strncmp(getenv("REMOTE_ADDR"),"194.200.2",9)==0) return 1;
 if(strcmp(getenv("HTTP_USER_AGENT"),"Dataflex NC device")==0) return 1;*/
 return 0;
}

int make_content(char *src)
{
 char *dst;
 int i;

 contents=0;
 dst=src;
 if(*src==0) return 0;
 while(*dst) {
  contents++;
  while((*dst)&&(*dst!='&')) dst++;
  if(*dst=='&') dst++;
 }
 content_str=malloc(contents*sizeof(char *));
 content_tag=malloc(contents*sizeof(char *));
 if((content_str==0)||(content_tag==0)) {
  server_error("The server has run out of memory");
  exit(0);
 }
 dst=src;
 i=0;
 while(*src) {
  content_tag[i]=dst;
  while((*src)&&(*src!='=')) *dst++=*src++;
  if(*src) {
   *dst++=*src++=0;
   content_str[i]=dst;
   while((*src)&&(*src!='&')) {
    switch(*src) {
     case '%' : /* Meta for hexadecimal bits... */
     {
      int a,b;
      src++;
      a=*src++;
      b=*src++;
      if(a>='a') a-=87;
      if(a>='A') a-=55;
      if(a>='0') a-=48;
      if(b>='a') b-=87;
      if(b>='A') b-=55;
      if(b>='0') b-=48;
      if(a>15) a=15;
      if(b>15) b=15;
      if(a<0) a=0;
      if(b<0) b=0;
      *dst++=(a<<4)|(b);
     }
     break;
     case '+' : /* Meta for space... */
     *dst++=' ';
     src++;
     break;
     default : /* Normal characters */
     *dst++=*src++;
     break;
    }
   }
   if(*src) src++;
   *dst++=0;
  }
  i++;
 }
 return contents;
}

char *get_content(char *tag)
{
 int i;

 for(i=0;i<contents;i++) {
  if(strcmp(content_tag[i],tag)==0) return content_str[i];
 }
 return 0;
}

char *make_http(char *item)
{
  char *buf=0,*p,*q;

  int len=0;
  p=item;
  while(*p) {
    if((*p=='+')||(*p<' ')||(*p=='@')||(*p=='.')||(*p=='%')||(*p=='&')||(*p=='?')) len+=3; else len++;
    p++;
  }
  buf=malloc(len+1);
  if(buf==0) return 0;

  p=item;
  while(*p) {
    if((*p=='+')||(*p<' ')||(*p=='@')||(*p=='.')||(*p=='%')||(*p=='&')||(*p=='?')) {
      sprintf(q,"%%%-.2X",*p);
      q+=3;
    } else *q++=*p++;
  }
  *q=0;
  return buf;
}
