#!/bin/sh

    ###################################
    # Install Script for My-hosts     #
    # Control panel                   #
    # Written by Bob                  #
    # Created 24th October            #
    ###################################

    ###################################
    # Variables                       #
    ###################################

    FILE=/home/vhosts/.admin/additional.pl
    TEMPLATE=/home/vhosts/.admin/additional_template.pl
    LOGFILE=/home/vhosts/.admin/docs/install.log

    ###################################
    # Check if file exsists and if it #
    # does make a backup              #
    ###################################

    if [ -f $FILE ]; then
    mv $FILE $FILE.old
    echo "Found config file making backup $FILE.old" >> $LOGFILE
    fi

    ###################################
    # Work out hostname and append    #
    # domain to it.                   #
    ###################################

    HOST=`cat /etc/sysconfig/network | grep HOSTNAME= | cut -d = -f 2 | cut -d '"' -f 2`

    ###################################
    # Build Server specific config    #
    # files                           #
    ###################################

    cp $TEMPLATE $FILE

    echo "\$server_name            = \"http://$HOST.aleeanne.org.uk\";" >> $FILE
    echo "4;" >> $FILE
    echo "Config File completed" >> $LOGFILE

    ###################################
    # Chowning file for webserver     #
    ###################################

    if [ -f $FILE ]; then
    chown www:www $FILE
    chmod 755 $FILE
    fi

    echo "Install completed" >> $LOGFILE
